import React, { Component } from "react";
import { Alert, Image, StyleSheet, View } from "react-native";
import { instructionData } from "./src/common/Services/instruction";
import { SCREEN_WIDTH, SCREEN_HEIGHT } from "./src/common/Constants";
import Header from "./src/Screens/Header";
import VechicleSurveyInstruction from "./src/Screens/VechicleSurveyInstruction";
import Orientation from "../../node_modules/react-native-orientation";
import { PrimaryButton } from "./src/common/ThemedComponents";
import { translate } from "react-native-digitcamera/src/common/localize/i18n";
import { connect } from "react-redux";
const camera = require("./src/common/Image/camera.png");
const recorder = require("./src/common/Image/recorder.png");
let index = 0;
// Global Veriables
let instuction = [];
var Retryinstuction = [];

class PI extends Component {
  constructor(props) {
    super(props);
    this.state = {
      title: "",
      subTitle: "",
      image: "",
      points: [],
      index: 0,
      totalSteps: "",
      staincil: "",
      imageName: "",
    };
  }
  componentWillUnmount() {
    this.unsubscribe();
  }
  componentDidMount() {
    this.unsubscribe = this.props.navigation.addListener("focus", () => {
      Orientation.lockToPortrait();
      //  call retry logic
      let index = 0;
          console.log("IN did Mount >>>> ",this.props.RetryCountData.retryCountInfo);
    if (this.props.RetryCountData.retryCountInfo.retryCount>0) {
      console.log("  IN IF ");
            this.updateRetryInstruction();
    } else {
            console.log("  IN ELSE ");
      // frist try
      this.callInstructionServices();
      instuction = [];
    }
    });

  }
  updateRetryInstruction = () => {
    if(this.props.RetryCountData.retryCountInfo.isAddNewImageData){
    // set new data And Clear the old of retry image data only when click on retake in incorectImages.js
    Retryinstuction=this.props.RetryImageData.retryImageInfo
        index=this.props.RetryCountData.retryCountInfo.index
    this.props.retryImageAction()
    this.props.retryCountAction({
          retryCount:Number(this.props.RetryCountData.retryCountInfo.retryCount),
        index:this.props.RetryCountData.retryCountInfo.index,
      isAddNewImageData:false
    })
    }
    if (index < Retryinstuction.length) {
      this.setState({
        title: Retryinstuction[index].title,
        staincil:
          Retryinstuction[index].stepStencilAssests,
        imageName: Retryinstuction[index].imageName,
        subTitle: Retryinstuction[index].subTitle,
        image: Retryinstuction[index].image,
        points: Retryinstuction[index].points,
        totalSteps: Retryinstuction.length,
      });
    }
  };
  callInstructionServices = async () => {
    if (false) {
    } else {
      let V_instuction = await instructionData({
        typeId: "5",
      });

      V_instuction.TSurveySteps.map((item) => {
        instuction.push(item);
      });

      // One Time call from here
      this.updateInstructionData();
    }
  };

  updateInstructionData() {
    if (index < instuction.length) {
      this.setState({
        title: instuction[index].stepTitle,
        staincil: instuction[index].stepStencilAssests,
        imageName: instuction[index].imageName,
        subTitle: instuction[index].description,
        image: instuction[index].stepAssests,
        points: instuction[index].TSurveyInstructions,
        totalSteps: instuction.length,
      });
    }
  }
  render() {
    return (
      <View style={styles.main}>
        <Header
          currentStep={index}
          totalSteps={this.state.totalSteps}
          showSteps={true}
          onbackPress={() => {
            if (index<instuction.length && this.props.RetryCountData.retryCountInfo.retryCount==0) {
             index = index - 1;
                this.setState({
                  title: instuction[index].stepTitle,
                  staincil: instuction[index].stepStencilAssests,
                  imageName: instuction[index].imageName,
                  subTitle: instuction[index].description,
                  image: instuction[index].stepAssests,
                  points: instuction[index].TSurveyInstructions,
                  totalSteps: instuction.length,
                });
              
            } else {
              if (index > 0) {
                index = index - 1;
              this.setState({
                title: Retryinstuction[index].title,
                staincil:
                  Retryinstuction[index]
                    .stepStencilAssests,
                imageName:
                  Retryinstuction[index].imageName,
                subTitle:
                  Retryinstuction[index].subTitle,
                image: Retryinstuction[index].image,
                points: Retryinstuction[index].points,
                totalSteps: Retryinstuction.length,
              });
            }
          }
          }
        }
        ></Header>
        {/* Instructions */}
        <VechicleSurveyInstruction
          title={this.state.title}
          subTitle={this.state.subTitle}
          image={this.state.image}
          points={this.state.points}
        />
        {this.state.title == "CNG Kit" ? (
          <PrimaryButton
            style={{ marginBottom: 24, marginRight: 24, marginLeft: 24 }}
            mode={"outlined"}
            color={"#FFFFFF"}
            onPress={() => {
              //show next steps and re render the data on screen
              index = index + 1;
              this.updateInstructionData();
            }}
          >
            {translate("Skip this step")}
          </PrimaryButton>
        ) : null}

        <PrimaryButton
          style={{ marginBottom: 24, marginRight: 24, marginLeft: 24 }}
          onPress={() => {
            console.log("KKKKKKKKKKKK", index, instuction.length);
                                          index = index + 1;
            // for first time instruction
            if(index<instuction.length && this.props.RetryCountData.retryCountInfo.retryCount==0 ){
    this.props.navigation.navigate("Camera", {
                  title: this.state.title,
                  stepStencilAssests: this.state.staincil,
                  DocumentImageName: this.state.imageName,
                  title: this.state.title,
                  subTitle: this.state.subTitle,
                  totalSteps: instuction.length,
                  points: this.state.points,
                  image:this.state.image,
                });
                this.updateInstructionData();
              
            }else{
              // use data in retry redux
  this.props.navigation.navigate("Camera", {
                  title: this.state.title,
                  stepStencilAssests: this.state.staincil,
                  DocumentImageName: this.state.imageName,
                  title: this.state.title,
                  subTitle: this.state.subTitle,
                  totalSteps: Retryinstuction.length,
                  points:this.state.points,
                  image:this.state.image,
                });
                this.updateRetryInstruction();
            }
          }}
          icon={({ color, size }) => {
            return this.state.title == "Take a 360° Video" ? (
              <Image source={recorder} style={{ width: 30, height: 30 }} />
            ) : (
              <Image source={camera} style={{ width: 30, height: 30 }} />
            );
          }}
        >
          {this.state.title == "Take a 360° Video"
            ? translate("Capture Video")
            : translate("Capture Image")}
        </PrimaryButton>
      </View>
    );
  }
}
const styles = StyleSheet.create({
  main: {
    backgroundColor: "#FFFFFF",
    flex: 1,
  },
});
const mapReductStateToProps = (reduxState) => {
  const { RetryCountData, RetryImageData } = reduxState;
  return { RetryCountData, RetryImageData };
};
const mapDispatchToProps = (dispatch) => {
  return {
       retryImageAction: data =>
      dispatch({
        type: 'CLEAR_RETRY_IMAGE_STATE'
      }),
      retryCountAction: data =>
      dispatch({
        type: 'RETRY_COUNT',
        payload: data,

      }),
  };
};

export default connect(mapReductStateToProps, mapDispatchToProps)(PI);